/**
 * Project Name:IDCardScanCaller
 * File Name:RecogActivity.java
 * Package Name:com.intsig.idcardscancaller
 * Date:2016年3月15日下午3:58:29
 * Copyright (c) 2016, 上海合合信息 All Rights Reserved.
 *
 */

package com.intsig.dlcardscansdkcaller;

import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Matrix;
import android.os.Bundle;
import android.support.v4.view.ViewPager;
import android.support.v4.view.ViewPager.OnPageChangeListener;
import android.text.TextUtils;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.view.Window;
import android.view.WindowManager;
import android.widget.ImageView;
import android.widget.ImageView.ScaleType;
import android.widget.LinearLayout;
import android.widget.PopupWindow;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.RadioGroup.OnCheckedChangeListener;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.intsig.commonui.MyZoomImageView;
import com.intsig.commonui.ViewPagerAdapter;
import com.intsig.dlcardscansdk.ISCardScanActivity;
import com.intsig.dlcardscansdk.ResultData;
import com.intsig.dlcardscansdkcaller.R;

public class RecogResultActivity extends Activity {
	//private static final String TAG = "RecogResultActivity";

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_NO_TITLE);

		setContentView(R.layout.ac_recog);
		Intent intent = getIntent();

		

		// TextView use_time_all_id = ((TextView)
		// findViewById(R.id.use_time_all_id));
		// use_time_all_id.setText(regtimeall);

		ResultData result = (ResultData) intent
				.getSerializableExtra(ISCardScanActivity.EXTRA_KEY_RESULT_DATA);

		String regtimeall = result.getRecgtimeString();

		// 图片角度,如果有图片的话
		if (TextUtils.isEmpty(regtimeall)) {
			findViewById(R.id.use_time_row_id).setVisibility(View.GONE);
		} else {

			((TextView) findViewById(R.id.use_time_id)).setText(regtimeall
					+ "ms");
		}
		String imagePath = result.getTrimImagePath();
//		String image_path = intent
//				.getStringExtra(ISCardScanActivity.EXTRA_KEY_RESULT_IMAGE);

		initPagerView(result.getOriImagePath(),imagePath);

		
		
		 //获取驾驶证姓名
		printPos(R.id.tv_label_name, R.id.tv_label_name_row,
				result.getName());
        //获取驾驶证国籍
		printPos(R.id.tv_label_national, R.id.tv_label_national_row,
				result.getNational());
        //获取驾驶证性别
		printPos(R.id.tv_label_sex, R.id.tv_label_sex_row,
				result.getSex());
        //获取驾驶证出生
		printPos(R.id.tv_label_birthday, R.id.tv_label_birthday_row,
				result.getBirthday());
        //获取驾驶证地址
		printPos(R.id.tv_label_address, R.id.tv_label_address_row,
				result.getAddress());
        //获取驾驶证号
		printPos(R.id.tv_label_id, R.id.tv_label_id_row,
				result.getId());
        //获取驾驶证初次领证日期
		printPos(R.id.tv_label_issuedate, R.id.tv_label_issuedate_row,
				result.getIssuedate());
        //获取驾驶证准驾类型
		printPos(R.id.tv_label_type, R.id.tv_label_type_row,
				result.getDrivetype());
        //获取驾驶证有效起始日期
		printPos(R.id.tv_label_validfrom, R.id.tv_label_validfrom_row,
				result.getValidfrom());
        //获取驾驶证有效结束日期
		printPos(R.id.tv_label_validfor, R.id.tv_label_validfor_row,
				result.getValidfor());
        
        //获取驾驶证有效期限
		printPos(R.id.tv_label_validity, R.id.tv_label_validity_row,
				result.getValidity());
       
		
		

	}

	public void printPos(int id, int rowid, String text) {

		if (TextUtils.isEmpty(text)) {
			findViewById(rowid).setVisibility(View.GONE);
		} else {
			((TextView) findViewById(id)).setText(text);

		}

	}

	public void onClick(View view) {
		if (!MainActivity.boolCheckAppKey) {

			Intent intent = new Intent(this, MainActivity.class);

			startActivity(intent);
			finish();
		} else {
			finish();
		}

	}

	// ***********************************UI***************************************/
	ViewPager vp;
	RadioGroup group;
	ViewPagerAdapter vpAdapter;
	int currentItem;
	Bitmap shotPathStringBmp;

	@SuppressWarnings("deprecation")
	public void initPagerView(String path1, String path2) {

		vp = (ViewPager) findViewById(R.id.viewpager);
		group = (RadioGroup) findViewById(R.id.RadioGroup);
		group.setOnCheckedChangeListener(listener);
		views = new ArrayList<View>();

		LinearLayout.LayoutParams mParams = new LinearLayout.LayoutParams(
				LinearLayout.LayoutParams.WRAP_CONTENT,
				LinearLayout.LayoutParams.WRAP_CONTENT);
		mParams.setMargins(20, 20, 20, 20);
		if (!TextUtils.isEmpty(path2)) {
			pathList.add(path2);
			MyZoomImageView iv2 = new MyZoomImageView(this);
			iv2.setLayoutParams(mParams);

			Bitmap bmp = loadBitmap(path2);
			if (bmp != null) {
				iv2.setImageBitmap(bmp);
			}

			iv2.setScaleType(ScaleType.FIT_CENTER);
			iv2.initUI();
			views.add(iv2);
		} else {
			group.setVisibility(View.GONE);
		}
		if (!TextUtils.isEmpty(path1)) {
			pathList.add(path1);
			MyZoomImageView iv = new MyZoomImageView(this);
			iv.setLayoutParams(mParams);

			Bitmap bmp = loadBitmap(path1);
			if (bmp != null) {
				iv.setImageBitmap(bmp);
			}

			iv.setScaleType(ScaleType.FIT_CENTER);
			iv.initUI();
			views.add(iv);
		} else {
			group.setVisibility(View.GONE);
		}
		vpAdapter = new ViewPagerAdapter(views);
		vp.setAdapter(vpAdapter);
		vp.setOnPageChangeListener(new OnPageChangeListener() {

			@Override
			public void onPageSelected(int position) {
				RadioButton radioButton = (RadioButton) group
						.getChildAt(position);
				radioButton.setChecked(true);
				currentItem = position;
			}

			@Override
			public void onPageScrolled(int arg0, float arg1, int arg2) {

			}

			@Override
			public void onPageScrollStateChanged(int arg0) {

			}
		});
		findViewById(R.id.rotation_title_id).setOnClickListener(
				new OnClickListener() {

					@Override
					public void onClick(View arg0) {
						// TODO Auto-generated method stub
						rotation[currentItem] = rotation[currentItem] + 90;
						if (rotation[currentItem] < 360) {
							setRoateImageview(rotation[currentItem]);
						} else {
							rotation[currentItem] = 0;
							setRoateImageview(rotation[currentItem]);
						}
					}
				});
	}

	int[] rotation = new int[2];
	List<View> views;
	List<String> pathList = new ArrayList<String>();

	public void setRoateImageview(int progress) {

		MyZoomImageView imageView = (MyZoomImageView) views.get(currentItem);
		// imageView.setDrawingCacheEnabled(true);
		Bitmap bitmap = loadBitmap(pathList.get(currentItem));
		// 设置旋转角度
		Matrix matrix = new Matrix();
		matrix.setRotate(progress);
		// 重新绘制Bitmap
		bitmap = Bitmap.createBitmap(bitmap, 0, 0, bitmap.getWidth(),
				bitmap.getHeight(), matrix, true);
		imageView.setImageBitmap(bitmap);
		// imageView.setDrawingCacheEnabled(false);
		imageView.setScaleType(ScaleType.FIT_CENTER);
		imageView.initUI();
	}

	OnCheckedChangeListener listener = new OnCheckedChangeListener() {

		@Override
		public void onCheckedChanged(RadioGroup group, int checkId) {
			switch (checkId) {
			case R.id.radio1:
				vp.setCurrentItem(0);
				currentItem = 0;
				break;
			case R.id.radio2:
				vp.setCurrentItem(1);
				currentItem = 1;
				break;

			default:
				break;
			}
		}
	};

	public void setBackgroundAlpha(float bgAlpha) {
		WindowManager.LayoutParams lp = getWindow().getAttributes();
		if (bgAlpha == 1) {
			getWindow().clearFlags(WindowManager.LayoutParams.FLAG_DIM_BEHIND);// 不移除该Flag的话,在有视频的页面上的视频会出现黑屏的bug
		} else {
			getWindow().addFlags(WindowManager.LayoutParams.FLAG_DIM_BEHIND);// 此行代码主要是解决在华为手机上半透明效果无效的bug
		}
		lp.alpha = bgAlpha;

		RecogResultActivity.this.getWindow().setAttributes(lp);
	}

	String shotPathString;
	TextView tv_label_id;
	OnClickListener onClickListenerTrim = new OnClickListener() {

		@Override
		public void onClick(View arg0) {
			// TODO Auto-generated method stub
			RelativeLayout layout = (RelativeLayout) LayoutInflater.from(
					RecogResultActivity.this).inflate(
					R.layout.cui_view_loadingdialog, null);
			final PopupWindow popupWindow = new PopupWindow(layout,
					ViewGroup.LayoutParams.WRAP_CONTENT,
					ViewGroup.LayoutParams.WRAP_CONTENT, true);

			ImageView loading_image = (ImageView) layout
					.findViewById(R.id.loading_image);
			Bitmap bmp = shotPathStringBmp;
			if (bmp != null) {
				loading_image.setImageBitmap(bmp);

			}
			setBackgroundAlpha(0.8f);
			popupWindow.showAsDropDown(tv_label_id);

			popupWindow.setOutsideTouchable(true);
			popupWindow.setTouchable(true);
			popupWindow.setFocusable(true);
			layout.setOnClickListener(new OnClickListener() {

				@Override
				public void onClick(View arg0) {
					// TODO Auto-generated method stub
					Log.e("setBackgroundAlpha", "1f");
					setBackgroundAlpha(1f);

					popupWindow.dismiss();
				}
			});

		}
	};

	public static Bitmap loadBitmap(String pathName) {
		Bitmap b = null;
		try {
			BitmapFactory.Options opts = new BitmapFactory.Options();
			opts.inPreferredConfig = Bitmap.Config.RGB_565;
			b = BitmapFactory.decodeFile(pathName, opts);
		} catch (Exception e) {
			e.printStackTrace();
			b = null;
		} catch (OutOfMemoryError e) {
			e.printStackTrace();
			b = null;
		}
		return b;
	}
}
